/*
 * Copyright (c) 2013, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/*
 *  ======== _alg.h ========
 */
#ifndef ti_sdo_ce_alg__ALG_
#define ti_sdo_ce_alg__ALG_

#ifdef __cplusplus
extern "C" {
#endif

#include <xdc/runtime/knl/SemProcess.h>

/**
 *  Number of group Ids for algorithms sharing resources. These group Ids
 *  should range between 0 and _ALG_NUMGROUPS - 1. If an algorithm's group Id
 *  is outside of this range, there will be no way to guarentee exclusive
 *  access of resources to this algorithm.
 *  TODO: Should this be a config parameter?
 */
extern unsigned int ti_sdo_ce_alg_Algorithm_MAXGROUPID;

#define _ALG_NUMGROUPS ti_sdo_ce_alg_Algorithm_MAXGROUPID

/* Auto-generated by Settings.xdt */
extern int _ALG_groupUsed[];

extern Int _ALG_groupRefCount[];

/*
 *  ======== _ALG_sems ========
 */
/**
 *  Semaphores for aquiring resources for algorithms of a given group Id.
 */
extern SemProcess_Handle _ALG_sems[];


/*
 *  ======== _ALG_allocMemory ========
 */
extern Bool _ALG_allocMemory(IALG_MemRec *memTab, Int n);

/*
 *  ======== _ALG_allocMemory2 ========
 */
extern Bool _ALG_allocMemory2(IALG_MemRec *memTab, Int n, UInt32 useCachedMem);

/*
 *  ======== _ALG_freeMemory ========
 */
extern Void _ALG_freeMemory(IALG_MemRec *memTab, Int n);

/*
 *  ======== _ALG_freeMemory2 ========
 */
extern Void _ALG_freeMemory2(IALG_MemRec *memTab, Int n, UInt32 useCachedMem);

#ifdef __cplusplus
}
#endif

#endif
